OGRE: Ogre::GpuProgram Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::GpuProgram Class Referenceabstract
Core » Resources

Defines a program which runs on the GPU such as a vertex or fragment program. More...

`#include <OgreGpuProgram.h>`

Inheritance diagram for Ogre::GpuProgram:
[legend]

## Public Member Functions
| GpuProgram (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
virtual | ~GpuProgram ()
virtual GpuProgram * | _getBindingDelegate (void)
| Returns the GpuProgram which should be bound to the pipeline.
uint32 | _getHash (uint32 seed=0) const
| internal method to get the microcode cache id
size_t | calculateSize (void) const override
| Calculate the size of a resource; this will only be called after 'load'.
virtual GpuProgramParametersSharedPtr | createParameters (void)
| Creates a new parameters object compatible with this program definition.
virtual const GpuNamedConstants & | getConstantDefinitions ()
| Get the full list of named constants.
virtual const GpuProgramParametersPtr & | getDefaultParameters (void)
| Get a reference to the default parameters which are to be used for all uses of this program.
virtual const String & | getLanguage (void) const
| Returns a string that specifies the language of the gpu programs as specified in a material script.
const String & | getManualNamedConstantsFile () const
| Gets the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.
virtual bool | getPassFogStates (void) const
| Returns whether a fragment program wants fog state to be passed through fixed pipeline low level API rendering calls (default true, subclasses can override).
virtual bool | getPassSurfaceAndLightStates (void) const
| Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls (default false, subclasses can override).
virtual bool | getPassTransformStates (void) const
| Returns whether a vertex program wants transform state to be passed through fixed pipeline low level API rendering calls.
virtual const String & | getSource (void) const
| Gets the assembler source for this program.
const String & | getSourceFile (void) const
| Gets the name of the file used as source for this program.
const String & | getSyntaxCode (void) const
| Gets the syntax code for this program e.g.
GpuProgramType | getType (void) const
| Get the program type.
virtual bool | hasCompileError (void) const
| Did this program encounter a compile error when loading?
virtual bool | hasDefaultParameters (void) const
| Returns true if default parameters have been set up.
virtual bool | isSupported (void) const
| Returns whether this program can be supported on the current renderer and hardware.
virtual bool | isVertexTextureFetchRequired (void) const
| Returns whether this vertex program requires support for vertex texture fetch from the hardware.
virtual void | resetCompileError (void)
| Reset a compile error if it occurred, allowing the load to be retried.
void | setManualNamedConstants (const GpuNamedConstants &namedConstants)
| Allows you to manually provide a set of named parameter mappings to a program which would not be able to derive named parameters itself.
void | setManualNamedConstantsFile (const String &paramDefFile)
| Specifies the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.
void | setSource (const String &source)
| Sets the source assembly for this program from an in-memory string.
void | setSourceFile (const String &filename)
| Sets the filename of the source assembly for this program.
void | setSyntaxCode (const String &syntax)
| Sets the syntax code for this program e.g.
void | setType (GpuProgramType t)
| Set the program type (only valid before load).
virtual void | setVertexTextureFetchRequired (bool r)
| Sets whether this vertex program requires support for vertex texture fetch from the hardware.
GPU offloading features
void | setInstancingIncluded (bool included)
| Sets whether a vertex program can do instancing.
bool | isInstancingIncluded (void) const
| Returns whether a vertex program can do instancing.
virtual void | setSkeletalAnimationIncluded (bool included)
| Sets whether a vertex program can do skeletal animation.
virtual bool | isSkeletalAnimationIncluded (void) const
| Returns whether a vertex program can do skeletal animation.
virtual void | setMorphAnimationIncluded (bool included)
| Sets whether a vertex program can do morph animation.
virtual void | setPoseAnimationIncluded (ushort poseCount)
| Sets whether a vertex program can do pose animation.
virtual bool | isMorphAnimationIncluded (void) const
| Returns whether a vertex program can do morph animation.
virtual bool | isPoseAnimationIncluded (void) const
| Returns whether a vertex program can do pose animation.
virtual ushort | getNumberOfPosesIncluded (void) const
| Returns the number of simultaneous poses the vertex program can blend, for use in pose animation.
Public Member Functions inherited from Ogre::Resource
| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
void | _fireLoadingComplete (bool unused=false)
| Firing of loading complete event.
void | _firePreparingComplete (bool unused=false)
| Firing of preparing complete event.
void | _fireUnloadingComplete (void)
| Firing of unloading complete event.
void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
const String & | getGroup (void) const
| Gets the group which this resource is a member of.
ResourceHandle | getHandle (void) const
LoadingState | getLoadingState () const
| Returns the current loading state.
const String & | getName (void) const
| Gets resource name.
const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise.
bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used.
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.

## Static Public Member Functions
static const String | getProgramTypeName (GpuProgramType programType)
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Additional Inherited Members
Public Types inherited from Ogre::Resource
enum | LoadingFlags { LF_DEFAULT = 0 , LF_INCLUDE_NON_RELOADABLE = 1 , LF_ONLY_UNREFERENCED = 2 , LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3 , LF_PRESERVE_STATE = 4 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED , LOADSTATE_LOADING , LOADSTATE_LOADED , LOADSTATE_UNLOADING , LOADSTATE_PREPARED , LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...

## Detailed Description

Defines a program which runs on the GPU such as a vertex or fragment program.

This class defines the low-level program in assembler code, the sort used to directly assemble into machine instructions for the GPU to execute. By nature, this means that the assembler source is rendersystem specific, which is why this is an abstract class - real instances are created through the RenderSystem. If you wish to use higher level shading languages like HLSL and Cg, you need to use the HighLevelGpuProgram class instead.

## Constructor & Destructor Documentation

## ◆ GpuProgram()

Ogre::GpuProgram::GpuProgram | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0 )

Referenced by _getBindingDelegate(), and Ogre::HighLevelGpuProgram::_getBindingDelegate().

## ◆ ~GpuProgram()

virtual Ogre::GpuProgram::~GpuProgram | ( |  | ) |
| inlinevirtual

## Member Function Documentation

## ◆ getProgramTypeName()

const String Ogre::GpuProgram::getProgramTypeName | ( | GpuProgramType | programType | ) |
| static

Referenced by Ogre::to_string().

## ◆ setSourceFile()

void Ogre::GpuProgram::setSourceFile | ( | const String & | filename | ) |

Sets the filename of the source assembly for this program.

Setting this will have no effect until you (re)load the program.

## ◆ setSource()

void Ogre::GpuProgram::setSource | ( | const String & | source | ) |

Sets the source assembly for this program from an in-memory string.

Setting this will have no effect until you (re)load the program.

## ◆ getSyntaxCode()

const String & Ogre::GpuProgram::getSyntaxCode | ( | void |  | ) | const
| inline

Gets the syntax code for this program e.g.

arbvp1, fp20, vs_1_1 etc

## ◆ setSyntaxCode()

void Ogre::GpuProgram::setSyntaxCode | ( | const String & | syntax | ) |

Sets the syntax code for this program e.g.

arbvp1, fp20, vs_1_1 etc

## ◆ getSourceFile()

const String & Ogre::GpuProgram::getSourceFile | ( | void |  | ) | const
| inline

Gets the name of the file used as source for this program.

## ◆ getSource()

virtual const String & Ogre::GpuProgram::getSource | ( | void |  | ) | const
| inlinevirtual

Gets the assembler source for this program.

## ◆ setType()

void Ogre::GpuProgram::setType | ( | GpuProgramType | t | ) |

Set the program type (only valid before load).

## ◆ getType()

GpuProgramType Ogre::GpuProgram::getType | ( | void |  | ) | const
| inline

Get the program type.

## ◆ _getBindingDelegate()

virtual GpuProgram * Ogre::GpuProgram::_getBindingDelegate | ( | void |  | ) |
| inlinevirtual

Returns the GpuProgram which should be bound to the pipeline.

This method is simply to allow some subclasses of GpuProgram to delegate the program which is bound to the pipeline to a delegate, if required.

Reimplemented in Ogre::CgProgram, and Ogre::HighLevelGpuProgram.

References GpuProgram().

## ◆ isSupported()

virtual bool Ogre::GpuProgram::isSupported | ( | void |  | ) | const
| virtual

Returns whether this program can be supported on the current renderer and hardware.

Reimplemented in Ogre::CgProgram, and Ogre::GLSLangProgram.

## ◆ createParameters()

virtual GpuProgramParametersSharedPtr Ogre::GpuProgram::createParameters | ( | void |  | ) |
| virtual

Creates a new parameters object compatible with this program definition.

It is recommended that you use this method of creating parameters objects rather than going direct to GpuProgramManager, because this method will populate any implementation-specific extras (like named parameters) where they are appropriate.

Reimplemented in Ogre::CgProgram, and Ogre::HighLevelGpuProgram.

## ◆ setInstancingIncluded()

void Ogre::GpuProgram::setInstancingIncluded | ( | bool | included | ) |
| inline

Sets whether a vertex program can do instancing.

If this is set to true, OGRE will provide an instance buffer holding the World Matrix of each instance to the vertex program.

## ◆ isInstancingIncluded()

bool Ogre::GpuProgram::isInstancingIncluded | ( | void |  | ) | const
| inline

Returns whether a vertex program can do instancing.

## ◆ setSkeletalAnimationIncluded()

virtual void Ogre::GpuProgram::setSkeletalAnimationIncluded | ( | bool | included | ) |
| inlinevirtual

Sets whether a vertex program can do skeletal animation.

If this is set to true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

## ◆ isSkeletalAnimationIncluded()

virtual bool Ogre::GpuProgram::isSkeletalAnimationIncluded | ( | void |  | ) | const
| inlinevirtual

Returns whether a vertex program can do skeletal animation.

If this returns true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

Reimplemented in Ogre::CgProgram.

## ◆ setMorphAnimationIncluded()

virtual void Ogre::GpuProgram::setMorphAnimationIncluded | ( | bool | included | ) |
| inlinevirtual

Sets whether a vertex program can do morph animation.

If this is set to true, OGRE will not blend the geometry according to morph animation, it will expect the vertex program to do it.

## ◆ setPoseAnimationIncluded()

virtual void Ogre::GpuProgram::setPoseAnimationIncluded | ( | ushort | poseCount | ) |
| inlinevirtual

Sets whether a vertex program can do pose animation.

If this is set to true, OGRE will not blend the geometry according to pose animation, it will expect the vertex program to do it.

Parameters

  poseCount | The number of simultaneous poses the program can blend

## ◆ isMorphAnimationIncluded()

virtual bool Ogre::GpuProgram::isMorphAnimationIncluded | ( | void |  | ) | const
| inlinevirtual

Returns whether a vertex program can do morph animation.

If this returns true, OGRE will not blend the geometry according to morph animation, it will expect the vertex program to do it.

Reimplemented in Ogre::CgProgram.

## ◆ isPoseAnimationIncluded()

virtual bool Ogre::GpuProgram::isPoseAnimationIncluded | ( | void |  | ) | const
| inlinevirtual

Returns whether a vertex program can do pose animation.

If this returns true, OGRE will not blend the geometry according to pose animation, it will expect the vertex program to do it.

Reimplemented in Ogre::CgProgram.

## ◆ getNumberOfPosesIncluded()

virtual ushort Ogre::GpuProgram::getNumberOfPosesIncluded | ( | void |  | ) | const
| inlinevirtual

Returns the number of simultaneous poses the vertex program can blend, for use in pose animation.

## ◆ setVertexTextureFetchRequired()

virtual void Ogre::GpuProgram::setVertexTextureFetchRequired | ( | bool | r | ) |
| inlinevirtual

Sets whether this vertex program requires support for vertex texture fetch from the hardware.

## ◆ isVertexTextureFetchRequired()

virtual bool Ogre::GpuProgram::isVertexTextureFetchRequired | ( | void |  | ) | const
| inlinevirtual

Returns whether this vertex program requires support for vertex texture fetch from the hardware.

Reimplemented in Ogre::CgProgram.

## ◆ getDefaultParameters()

virtual const GpuProgramParametersPtr & Ogre::GpuProgram::getDefaultParameters | ( | void |  | ) |
| virtual

Get a reference to the default parameters which are to be used for all uses of this program.

A program can be set up with a list of default parameters, which can save time when using a program many times in a material with roughly the same settings. By retrieving the default parameters and populating it with the most used options, any new parameter objects created from this program afterwards will automatically include the default parameters; thus users of the program need only change the parameters which are unique to their own usage of the program.

Reimplemented in Ogre::CgProgram.

## ◆ hasDefaultParameters()

virtual bool Ogre::GpuProgram::hasDefaultParameters | ( | void |  | ) | const
| inlinevirtual

Returns true if default parameters have been set up.

Reimplemented in Ogre::CgProgram.

## ◆ getPassSurfaceAndLightStates()

virtual bool Ogre::GpuProgram::getPassSurfaceAndLightStates | ( | void |  | ) | const
| inlinevirtual

Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls (default false, subclasses can override).

Most vertex programs do not need this material information, however GLSL shaders can refer to this material and lighting state so enable this option

Reimplemented in Ogre::CgProgram.

## ◆ getPassFogStates()

virtual bool Ogre::GpuProgram::getPassFogStates | ( | void |  | ) | const
| inlinevirtual

Returns whether a fragment program wants fog state to be passed through fixed pipeline low level API rendering calls (default true, subclasses can override).

On DirectX, shader model 2 and earlier continues to have fixed-function fog applied to it, so fog state is still passed (you should disable fog on the pass if you want to perform fog in the shader). In OpenGL it is also common to be able to access the fixed-function fog state inside the shader.

Reimplemented in Ogre::CgProgram.

## ◆ getPassTransformStates()

virtual bool Ogre::GpuProgram::getPassTransformStates | ( | void |  | ) | const
| inlinevirtual

Returns whether a vertex program wants transform state to be passed through fixed pipeline low level API rendering calls.

Most vertex programs do not need fixed-function transform information, however GLSL shaders can refer to this state so enable this option

Reimplemented in Ogre::CgProgram.

## ◆ getLanguage()

virtual const String & Ogre::GpuProgram::getLanguage | ( | void |  | ) | const
| virtual

Returns a string that specifies the language of the gpu programs as specified in a material script.

ie: asm, cg, hlsl, glsl

Reimplemented in Ogre::CgProgram, and Ogre::GLSLangProgram.

## ◆ hasCompileError()

virtual bool Ogre::GpuProgram::hasCompileError | ( | void |  | ) | const
| inlinevirtual

Did this program encounter a compile error when loading?

Reimplemented in Ogre::CgProgram.

## ◆ resetCompileError()

virtual void Ogre::GpuProgram::resetCompileError | ( | void |  | ) |
| inlinevirtual

Reset a compile error if it occurred, allowing the load to be retried.

Reimplemented in Ogre::CgProgram.

## ◆ setManualNamedConstants()

void Ogre::GpuProgram::setManualNamedConstants | ( | const GpuNamedConstants & | namedConstants | ) |

Allows you to manually provide a set of named parameter mappings to a program which would not be able to derive named parameters itself.

You may wish to use this if you have assembler programs that were compiled from a high-level source, and want the convenience of still being able to use the named parameters from the original high-level source.

See also
  setManualNamedConstantsFile

## ◆ setManualNamedConstantsFile()

void Ogre::GpuProgram::setManualNamedConstantsFile | ( | const String & | paramDefFile | ) |

Specifies the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.

You may wish to use this if you have assembler programs that were compiled from a high-level source, and want the convenience of still being able to use the named parameters from the original high-level source. This method will make a low-level program search in the resource group of the program for the named file from which to load parameter names from. The file must be in the format produced by GpuNamedConstants::save.

## ◆ getManualNamedConstantsFile()

const String & Ogre::GpuProgram::getManualNamedConstantsFile | ( |  | ) | const
| inline

Gets the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.

## ◆ getConstantDefinitions()

virtual const GpuNamedConstants & Ogre::GpuProgram::getConstantDefinitions | ( |  | ) |
| inlinevirtual

Get the full list of named constants.

Note
  Only available if this parameters object has named parameters, which means either a high-level program which loads them, or a low-level program which has them specified manually.

Reimplemented in Ogre::HighLevelGpuProgram.

## ◆ calculateSize()

size_t Ogre::GpuProgram::calculateSize | ( | void |  | ) | const
| overridevirtual

Calculate the size of a resource; this will only be called after 'load'.

Reimplemented from Ogre::Resource.

Reimplemented in Ogre::HighLevelGpuProgram.

## ◆ _getHash()

uint32 Ogre::GpuProgram::_getHash | ( | uint32 | seed = 0 | ) | const

internal method to get the microcode cache id

The documentation for this class was generated from the following file:

- OgreGpuProgram.h